/* eslint-disable */
/*
 * This file was auto-generated by `make update-types`.
 * DO NOT make changes to this file.
 */

export interface paths {
  '/api/v1/categories/': {
    /** List all categories. */
    get: operations['categories_list']
    /** Create a new category. */
    post: operations['categories_create']
  }
  '/api/v1/categories/{id}/': {
    /** Retrieve a single category. */
    get: operations['categories_retrieve']
    /** Update an existing category. */
    put: operations['categories_update']
    /** Delete an existing category. */
    delete: operations['categories_destroy']
    /** Partially update an existing category. */
    patch: operations['categories_partial_update']
  }
  '/api/v1/fundingcategories/': {
    /** List all funding categories. */
    get: operations['fundingcategories_list']
    /** Create a new funding category. */
    post: operations['fundingcategories_create']
  }
  '/api/v1/fundingcategories/{id}/': {
    /** Retrieve a single funding category. */
    get: operations['fundingcategories_retrieve']
    /** Update an existing funding category. */
    put: operations['fundingcategories_update']
    /** Delete an existing funding category. */
    delete: operations['fundingcategories_destroy']
    /** Partially update an existing funding category. */
    patch: operations['fundingcategories_partial_update']
  }
  '/api/v1/hosts/': {
    /** List all hosts. */
    get: operations['hosts_list']
    /** Create a new host. */
    post: operations['hosts_create']
  }
  '/api/v1/hosts/{id}/': {
    /** Retrieve a single host. */
    get: operations['hosts_retrieve']
    /** Update an existing host. */
    put: operations['hosts_update']
    /** Delete an existing host. */
    delete: operations['hosts_destroy']
    /** Partially update an existing host. */
    patch: operations['hosts_partial_update']
  }
  '/api/v1/languages/': {
    /** List all languages. */
    get: operations['languages_list']
    /** Create a new language. */
    post: operations['languages_create']
  }
  '/api/v1/languages/{id}/': {
    /** Retrieve a single language. */
    get: operations['languages_retrieve']
    /** Update an existing language. */
    put: operations['languages_update']
    /** Delete an existing language. */
    delete: operations['languages_destroy']
    /** Partially update an existing language. */
    patch: operations['languages_partial_update']
  }
  '/api/v1/musicfocus/': {
    /** List all music focuses. */
    get: operations['musicfocus_list']
    /** Create a new music focus. */
    post: operations['musicfocus_create']
  }
  '/api/v1/musicfocus/{id}/': {
    /** Retrieve a single music focus. */
    get: operations['musicfocus_retrieve']
    /** Update an existing music focus. */
    put: operations['musicfocus_update']
    /** Delete an existing music focus. */
    delete: operations['musicfocus_destroy']
    /** Partially update an existing music focus. */
    patch: operations['musicfocus_partial_update']
  }
  '/api/v1/notes/': {
    /** List all notes. */
    get: operations['notes_list']
    /**
     * Create a new note.
     * @description Only admins can create new notes.
     */
    post: operations['notes_create']
  }
  '/api/v1/notes/{id}/': {
    /** Retrieve a single note. */
    get: operations['notes_retrieve']
    /**
     * Update an existing note.
     * @description Only admins can update existing notes.
     */
    put: operations['notes_update']
    /**
     * Delete an existing note.
     * @description Only admins can delete existing notes.
     */
    delete: operations['notes_destroy']
    /**
     * Partially update an existing note.
     * @description Only admins can partially update existing notes.
     */
    patch: operations['notes_partial_update']
  }
  '/api/v1/schedules/': {
    /** List all schedules. */
    get: operations['schedules_list']
    /**
     * Create a new schedule.
     * @description Create a schedule, generate timeslots, test for collisions and resolve them
     * (including notes).
     *
     * Note that creating or updating a schedule is the only way to create timeslots.
     *
     * Only admins may add schedules.
     *
     * The projected timeslots defined by the schedule are matched against existing
     * timeslots. The API will return an object that contains
     *
     * * the schedule's data,
     * * projected timeslots,
     * * detected collisions,
     * * and possible solutions.
     *
     * As long as no `solutions` object has been set or unresolved collisions exist,
     * no data is written to the database. A schedule is only created if at least
     * one timeslot was generated by it.
     *
     * In order to resolve any possible conflicts, the client must submit a new request with
     * a solution for each conflict. Possible solutions are listed as part of the projected
     * timeslot in the `solution_choices` array. In a best-case scenario with no detected
     * conflicts an empty solutions object will suffice. For more details on the individual
     * types of solutions see the SolutionChoicesEnum.
     *
     * **Please note**:
     * If there's more than one collision for a projected timeslot, only `theirs` and `ours`
     * are currently supported as solutions.
     */
    post: operations['schedules_create']
  }
  '/api/v1/schedules/{id}/': {
    /** Retrieve a single schedule. */
    get: operations['schedules_retrieve']
    /**
     * Update an existing schedule.
     * @description Update a schedule, generate timeslots, test for collisions and resolve
     * them including notes.
     *
     * Only admins may update schedules.
     */
    put: operations['schedules_update']
    /**
     * Delete an existing schedule.
     * @description Only admins may delete schedules.
     */
    delete: operations['schedules_destroy']
    /** Partially update an existing schedule. */
    patch: operations['schedules_partial_update']
  }
  '/api/v1/schema/': {
    /**
     * @description OpenApi3 schema for this API. Format can be selected via content negotiation.
     *
     * - YAML: application/vnd.oai.openapi
     * - JSON: application/vnd.oai.openapi+json
     */
    get: operations['schema_retrieve']
  }
  '/api/v1/shows/': {
    /** List all shows. */
    get: operations['shows_list']
    /**
     * Create a new show.
     * @description Only admins may create a show.
     */
    post: operations['shows_create']
  }
  '/api/v1/shows/{id}/': {
    /** Retrieve a single show. */
    get: operations['shows_retrieve']
    /**
     * Update an existing show.
     * @description Non-admin users may only update shows they own.
     */
    put: operations['shows_update']
    /**
     * Delete an existing show.
     * @description Only admins may delete shows.
     */
    delete: operations['shows_destroy']
    /** Partially update an existing show. */
    patch: operations['shows_partial_update']
  }
  '/api/v1/shows/{show_pk}/notes/': {
    /** List all notes. */
    get: operations['shows_notes_list']
    /**
     * Create a new note.
     * @description Only admins can create new notes.
     */
    post: operations['shows_notes_create']
  }
  '/api/v1/shows/{show_pk}/notes/{id}/': {
    /** Retrieve a single note. */
    get: operations['shows_notes_retrieve']
    /**
     * Update an existing note.
     * @description Only admins can update existing notes.
     */
    put: operations['shows_notes_update']
    /**
     * Delete an existing note.
     * @description Only admins can delete existing notes.
     */
    delete: operations['shows_notes_destroy']
    /**
     * Partially update an existing note.
     * @description Only admins can partially update existing notes.
     */
    patch: operations['shows_notes_partial_update']
  }
  '/api/v1/shows/{show_pk}/schedules/': {
    /** List all schedules. */
    get: operations['shows_schedules_list']
    /**
     * Create a new schedule.
     * @description Create a schedule, generate timeslots, test for collisions and resolve them
     * (including notes).
     *
     * Note that creating or updating a schedule is the only way to create timeslots.
     *
     * Only admins may add schedules.
     *
     * The projected timeslots defined by the schedule are matched against existing
     * timeslots. The API will return an object that contains
     *
     * * the schedule's data,
     * * projected timeslots,
     * * detected collisions,
     * * and possible solutions.
     *
     * As long as no `solutions` object has been set or unresolved collisions exist,
     * no data is written to the database. A schedule is only created if at least
     * one timeslot was generated by it.
     *
     * In order to resolve any possible conflicts, the client must submit a new request with
     * a solution for each conflict. Possible solutions are listed as part of the projected
     * timeslot in the `solution_choices` array. In a best-case scenario with no detected
     * conflicts an empty solutions object will suffice. For more details on the individual
     * types of solutions see the SolutionChoicesEnum.
     *
     * **Please note**:
     * If there's more than one collision for a projected timeslot, only `theirs` and `ours`
     * are currently supported as solutions.
     */
    post: operations['shows_schedules_create']
  }
  '/api/v1/shows/{show_pk}/schedules/{id}/': {
    /** Retrieve a single schedule. */
    get: operations['shows_schedules_retrieve']
    /**
     * Update an existing schedule.
     * @description Update a schedule, generate timeslots, test for collisions and resolve
     * them including notes.
     *
     * Only admins may update schedules.
     */
    put: operations['shows_schedules_update']
    /**
     * Delete an existing schedule.
     * @description Only admins may delete schedules.
     */
    delete: operations['shows_schedules_destroy']
    /** Partially update an existing schedule. */
    patch: operations['shows_schedules_partial_update']
  }
  '/api/v1/shows/{show_pk}/schedules/{schedule_pk}/timeslots/': {
    /**
     * List all timeslots.
     * @description
     * By default, only timeslots ranging from now + 60 days will be displayed.
     * You may override this default overriding start and/or end parameter.
     */
    get: operations['shows_schedules_timeslots_list']
  }
  '/api/v1/shows/{show_pk}/schedules/{schedule_pk}/timeslots/{id}/': {
    /** Retrieve a single timeslot. */
    get: operations['shows_schedules_timeslots_retrieve']
    /** Update an existing timeslot. */
    put: operations['shows_schedules_timeslots_update']
    /**
     * Delete an existing timeslot.
     * @description Only admins may delete timeslots.
     */
    delete: operations['shows_schedules_timeslots_destroy']
    /** Partially update an existing timeslot. */
    patch: operations['shows_schedules_timeslots_partial_update']
  }
  '/api/v1/shows/{show_pk}/schedules/{schedule_pk}/timeslots/{timeslot_pk}/note/': {
    /** List all notes. */
    get: operations['shows_schedules_timeslots_note_list']
    /**
     * Create a new note.
     * @description Only admins can create new notes.
     */
    post: operations['shows_schedules_timeslots_note_create']
  }
  '/api/v1/shows/{show_pk}/schedules/{schedule_pk}/timeslots/{timeslot_pk}/note/{id}/': {
    /** Retrieve a single note. */
    get: operations['shows_schedules_timeslots_note_retrieve']
    /**
     * Update an existing note.
     * @description Only admins can update existing notes.
     */
    put: operations['shows_schedules_timeslots_note_update']
    /**
     * Delete an existing note.
     * @description Only admins can delete existing notes.
     */
    delete: operations['shows_schedules_timeslots_note_destroy']
    /**
     * Partially update an existing note.
     * @description Only admins can partially update existing notes.
     */
    patch: operations['shows_schedules_timeslots_note_partial_update']
  }
  '/api/v1/shows/{show_pk}/timeslots/': {
    /**
     * List all timeslots.
     * @description
     * By default, only timeslots ranging from now + 60 days will be displayed.
     * You may override this default overriding start and/or end parameter.
     */
    get: operations['shows_timeslots_list']
  }
  '/api/v1/shows/{show_pk}/timeslots/{id}/': {
    /** Retrieve a single timeslot. */
    get: operations['shows_timeslots_retrieve']
    /** Update an existing timeslot. */
    put: operations['shows_timeslots_update']
    /**
     * Delete an existing timeslot.
     * @description Only admins may delete timeslots.
     */
    delete: operations['shows_timeslots_destroy']
    /** Partially update an existing timeslot. */
    patch: operations['shows_timeslots_partial_update']
  }
  '/api/v1/shows/{show_pk}/timeslots/{timeslot_pk}/note/': {
    /** List all notes. */
    get: operations['shows_timeslots_note_list']
    /**
     * Create a new note.
     * @description Only admins can create new notes.
     */
    post: operations['shows_timeslots_note_create']
  }
  '/api/v1/shows/{show_pk}/timeslots/{timeslot_pk}/note/{id}/': {
    /** Retrieve a single note. */
    get: operations['shows_timeslots_note_retrieve']
    /**
     * Update an existing note.
     * @description Only admins can update existing notes.
     */
    put: operations['shows_timeslots_note_update']
    /**
     * Delete an existing note.
     * @description Only admins can delete existing notes.
     */
    delete: operations['shows_timeslots_note_destroy']
    /**
     * Partially update an existing note.
     * @description Only admins can partially update existing notes.
     */
    patch: operations['shows_timeslots_note_partial_update']
  }
  '/api/v1/timeslots/': {
    /**
     * List all timeslots.
     * @description
     * By default, only timeslots ranging from now + 60 days will be displayed.
     * You may override this default overriding start and/or end parameter.
     */
    get: operations['timeslots_list']
  }
  '/api/v1/timeslots/{id}/': {
    /** Retrieve a single timeslot. */
    get: operations['timeslots_retrieve']
    /** Update an existing timeslot. */
    put: operations['timeslots_update']
    /**
     * Delete an existing timeslot.
     * @description Only admins may delete timeslots.
     */
    delete: operations['timeslots_destroy']
    /** Partially update an existing timeslot. */
    patch: operations['timeslots_partial_update']
  }
  '/api/v1/topics/': {
    /** List all topics. */
    get: operations['topics_list']
    /** Create a new topic. */
    post: operations['topics_create']
  }
  '/api/v1/topics/{id}/': {
    /** Retrieve a single topic. */
    get: operations['topics_retrieve']
    /** Update an existing topic. */
    put: operations['topics_update']
    /** Delete an existing topic. */
    delete: operations['topics_destroy']
    /** Partially update an existing topic. */
    patch: operations['topics_partial_update']
  }
  '/api/v1/types/': {
    /** List all types. */
    get: operations['types_list']
    /** Create a new type. */
    post: operations['types_create']
  }
  '/api/v1/types/{id}/': {
    /** Retrieve a single type. */
    get: operations['types_retrieve']
    /** Update an existing type. */
    put: operations['types_update']
    /** Delete an existing type. */
    delete: operations['types_destroy']
    /** Partially update an existing type. */
    patch: operations['types_partial_update']
  }
  '/api/v1/users/': {
    /**
     * List all users.
     * @description The returned list of records will only contain a single record for non-admin users which is their own user account.
     */
    get: operations['users_list']
    /**
     * Create a new user.
     * @description Only admins may create users.
     */
    post: operations['users_create']
  }
  '/api/v1/users/{id}/': {
    /**
     * Retrieve a single user.
     * @description Non-admin users may only retrieve their own user record.
     */
    get: operations['users_retrieve']
    /**
     * Update an existing user.
     * @description Non-admin users may only update their own user record.
     */
    put: operations['users_update']
    /**
     * Partially update an existing user.
     * @description Non-admin users may only update their own user record.
     */
    patch: operations['users_partial_update']
  }
}

export type webhooks = Record<string, never>

export interface components {
  schemas: {
    /**
     * @description **0**: Monday
     *
     *
     * **1**: Tuesday
     *
     *
     * **2**: Wednesday
     *
     *
     * **3**: Thursday
     *
     *
     * **4**: Friday
     *
     *
     * **5**: Saturday
     *
     *
     * **6**: Sunday
     * @enum {integer}
     */
    ByWeekdayEnum: 0 | 1 | 2 | 3 | 4 | 5 | 6
    Category: {
      id: number
      category: string
      abbrev: string
      slug: string
      is_active?: boolean
      description?: string
    }
    Collision: {
      id: number
      /** Format: date-time */
      start: string
      /** Format: date-time */
      end: string
      playlist_id: number | null
      show: number
      show_name: string
      is_repetition: boolean
      schedule: number
      memo: string
      note_id: number | null
    }
    DryRunTimeSlot: {
      id: number | null
      schedule: number | null
      playlist_id: number | null
      /** Format: date */
      start: string
      /** Format: date */
      end: string
      is_repetition: boolean
      memo: string
    }
    Error: {
      message: string
      code: string | null
    }
    FundingCategory: {
      id: number
      fundingcategory: string
      abbrev: string
      slug: string
      is_active?: boolean
    }
    Host: {
      id: number
      links?: components['schemas']['HostLink'][]
      thumbnails: readonly string[]
      name: string
      is_active?: boolean
      /** Format: email */
      email?: string
      /** Format: uri */
      website?: string
      biography?: string | null
      ppoi: string
      height: number | null
      width: number | null
      /** Format: uri */
      image?: string | null
    }
    HostLink: {
      description: string
      /** Format: uri */
      url: string
    }
    Language: {
      id: number
      name: string
      is_active?: boolean
    }
    MusicFocus: {
      id: number
      focus: string
      abbrev: string
      slug: string
      is_active?: boolean
    }
    Note: {
      id: number
      links?: components['schemas']['NoteLink'][]
      show: number
      timeslot: number
      host: number
      thumbnails: readonly string[]
      title: string
      slug: string
      summary?: string
      content: string
      ppoi: string
      height: number | null
      width: number | null
      /** Format: uri */
      image?: string | null
      status?: number
      /** Format: date-time */
      start: string
      cba_id?: number | null
      user: number
    }
    NoteLink: {
      description: string
      /** Format: uri */
      url: string
    }
    PaginatedHostList: {
      /** @example 123 */
      count?: number
      /**
       * Format: uri
       * @example http://api.example.org/accounts/?offset=400&limit=100
       */
      next?: string | null
      /**
       * Format: uri
       * @example http://api.example.org/accounts/?offset=200&limit=100
       */
      previous?: string | null
      results?: components['schemas']['Host'][]
    }
    PaginatedNoteList: {
      /** @example 123 */
      count?: number
      /**
       * Format: uri
       * @example http://api.example.org/accounts/?offset=400&limit=100
       */
      next?: string | null
      /**
       * Format: uri
       * @example http://api.example.org/accounts/?offset=200&limit=100
       */
      previous?: string | null
      results?: components['schemas']['Note'][]
    }
    PaginatedShowList: {
      /** @example 123 */
      count?: number
      /**
       * Format: uri
       * @example http://api.example.org/accounts/?offset=400&limit=100
       */
      next?: string | null
      /**
       * Format: uri
       * @example http://api.example.org/accounts/?offset=200&limit=100
       */
      previous?: string | null
      results?: components['schemas']['Show'][]
    }
    PaginatedTimeSlotList: {
      /** @example 123 */
      count?: number
      /**
       * Format: uri
       * @example http://api.example.org/accounts/?offset=400&limit=100
       */
      next?: string | null
      /**
       * Format: uri
       * @example http://api.example.org/accounts/?offset=200&limit=100
       */
      previous?: string | null
      results?: components['schemas']['TimeSlot'][]
    }
    PatchedCategory: {
      id?: number
      category?: string
      abbrev?: string
      slug?: string
      is_active?: boolean
      description?: string
    }
    PatchedFundingCategory: {
      id?: number
      fundingcategory?: string
      abbrev?: string
      slug?: string
      is_active?: boolean
    }
    PatchedHost: {
      id?: number
      links?: components['schemas']['HostLink'][]
      thumbnails?: readonly string[]
      name?: string
      is_active?: boolean
      /** Format: email */
      email?: string
      /** Format: uri */
      website?: string
      biography?: string | null
      ppoi?: string
      height?: number | null
      width?: number | null
      /** Format: uri */
      image?: string | null
    }
    PatchedLanguage: {
      id?: number
      name?: string
      is_active?: boolean
    }
    PatchedMusicFocus: {
      id?: number
      focus?: string
      abbrev?: string
      slug?: string
      is_active?: boolean
    }
    PatchedNote: {
      id?: number
      links?: components['schemas']['NoteLink'][]
      show?: number
      timeslot?: number
      host?: number
      thumbnails?: readonly string[]
      title?: string
      slug?: string
      summary?: string
      content?: string
      ppoi?: string
      height?: number | null
      width?: number | null
      /** Format: uri */
      image?: string | null
      status?: number
      /** Format: date-time */
      start?: string
      cba_id?: number | null
      user?: number
    }
    PatchedScheduleCreateUpdateRequest: {
      schedule?: components['schemas']['ScheduleInRequest']
      solutions?: {
        [key: string]:
          | (
              | 'theirs'
              | 'ours'
              | 'theirs-start'
              | 'ours-start'
              | 'theirs-end'
              | 'ours-end'
              | 'theirs-both'
              | 'ours-both'
            )
          | undefined
      }
      notes?: {
        [key: string]: number | undefined
      }
      playlists?: {
        [key: string]: number | undefined
      }
    }
    PatchedShow: {
      id?: number
      name?: string
      slug?: string
      /** Format: uri */
      image?: string | null
      ppoi?: string
      /** Format: uri */
      logo?: string | null
      short_description?: string
      description?: string | null
      /** Format: email */
      email?: string | null
      /** Format: uri */
      website?: string | null
      type?: number
      fundingcategory?: number
      predecessor?: number | null
      cba_series_id?: number | null
      default_playlist_id?: number | null
      category?: number[]
      hosts?: number[]
      owners?: number[]
      language?: number[]
      topic?: number[]
      musicfocus?: number[]
      thumbnails?: readonly string[]
      is_active?: boolean
      is_public?: boolean
      links?: components['schemas']['HostLink'][]
    }
    PatchedTimeSlot: {
      id?: number
      show?: number
      schedule?: number
      /** Format: date-time */
      start?: string
      /** Format: date-time */
      end?: string
      memo?: string
      is_repetition?: boolean
      playlist_id?: number | null
      note_id?: number | null
    }
    PatchedTopic: {
      id?: number
      topic?: string
      abbrev?: string
      slug?: string
      is_active?: boolean
    }
    PatchedType: {
      id?: number
      type?: string
      slug?: string
      is_active?: boolean
    }
    PatchedUser: {
      id?: number
      /** @description Required. 150 characters or fewer. Letters, digits and @/./+/-/_ only. */
      username?: string
      first_name?: string
      last_name?: string
      /**
       * Email address
       * Format: email
       */
      email?: string
      /**
       * Staff status
       * @description Designates whether the user can log into this admin site.
       */
      is_staff?: boolean
      /**
       * Active
       * @description Designates whether this user should be treated as active. Unselect this instead of deleting accounts.
       */
      is_active?: boolean
      /**
       * Superuser status
       * @description Designates that this user has all permissions without explicitly assigning them.
       */
      is_superuser?: boolean
      password?: string
      profile?: components['schemas']['Profile']
    }
    Profile: {
      id: number
      cba_username?: string
      /** CBA Token */
      cba_user_token?: string
      user: number
    }
    ProjectedTimeSlot: {
      hash: string
      /** Format: date-time */
      start: string
      /** Format: date-time */
      end: string
      collisions: components['schemas']['Collision'][]
      error: string | null
      solution_choices: components['schemas']['SolutionChoicesEnum'][]
    }
    Schedule: {
      id: number
      /** @description Number of the Weekday. */
      by_weekday: components['schemas']['ByWeekdayEnum']
      /**
       * Format: date
       * @description Start date of schedule.
       */
      first_date: string
      /**
       * Format: time
       * @description Start time of schedule.
       */
      start_time: string
      /**
       * Format: time
       * @description End time of schedule.
       */
      end_time: string
      /**
       * Format: date
       * @description End date of schedule.
       */
      last_date: string
      /** @description Whether the schedule is a repetition. */
      is_repetition?: boolean
      /** @description Add a number of days to the generated dates. This can be useful for repetitions, like 'On the following day'. */
      add_days_no?: number | null
      /** @description Whether to add add_days_no but skipping the weekends. E.g. if weekday is Friday, the date returned will be the next Monday. */
      add_business_days_only?: boolean
      /** @description A tank ID in case the timeslot's playlist_id is empty. */
      default_playlist_id?: number | null
      /**
       * @description
       * A recurrence rule.
       *
       * * 1 = once,
       * * 2 = daily,
       * * 3 = business days,
       * * 4 = weekly,
       * * 5 = biweekly,
       * * 6 = every four weeks,
       * * 7 = every even calendar week (ISO 8601),
       * * 8 = every odd calendar week (ISO 8601),
       * * 9 = every 1st week of month,
       * * 10 = every 2nd week of month,
       * * 11 = every 3rd week of month,
       * * 12 = every 4th week of month,
       * * 13 = every 5th week of month
       */
      rrule: number
      /** @description Show the schedule belongs to. */
      show: number
    }
    ScheduleConflictResponse: {
      projected: components['schemas']['ProjectedTimeSlot'][]
      solutions: {
        [key: string]:
          | (
              | 'theirs'
              | 'ours'
              | 'theirs-start'
              | 'ours-start'
              | 'theirs-end'
              | 'ours-end'
              | 'theirs-both'
              | 'ours-both'
            )
          | undefined
      }
      notes: {
        [key: string]: number | undefined
      }
      playlists: {
        [key: string]: number | undefined
      }
      schedule: components['schemas']['UnsavedSchedule']
    }
    ScheduleCreateUpdateRequest: {
      schedule: components['schemas']['ScheduleInRequest']
      solutions?: {
        [key: string]:
          | (
              | 'theirs'
              | 'ours'
              | 'theirs-start'
              | 'ours-start'
              | 'theirs-end'
              | 'ours-end'
              | 'theirs-both'
              | 'ours-both'
            )
          | undefined
      }
      notes?: {
        [key: string]: number | undefined
      }
      playlists?: {
        [key: string]: number | undefined
      }
    }
    ScheduleDryRunResponse: {
      created: components['schemas']['DryRunTimeSlot'][]
      updated: components['schemas']['DryRunTimeSlot'][]
      deleted: components['schemas']['DryRunTimeSlot'][]
    }
    ScheduleInRequest: {
      id: number
      /** @description Whether to simulate the database changes. If true, no database changes will occur. Instead a list of objects that would be created, updated and deleted if dryrun was false will be returned. */
      dryrun?: boolean
      /** @description Number of the Weekday. */
      by_weekday: components['schemas']['ByWeekdayEnum']
      /**
       * Format: date
       * @description Start date of schedule.
       */
      first_date: string
      /**
       * Format: time
       * @description Start time of schedule.
       */
      start_time: string
      /**
       * Format: time
       * @description End time of schedule.
       */
      end_time: string
      /**
       * Format: date
       * @description End date of schedule.
       */
      last_date: string
      /** @description Whether the schedule is a repetition. */
      is_repetition?: boolean
      /** @description Add a number of days to the generated dates. This can be useful for repetitions, like 'On the following day'. */
      add_days_no?: number | null
      /** @description Whether to add add_days_no but skipping the weekends. E.g. if weekday is Friday, the date returned will be the next Monday. */
      add_business_days_only?: boolean
      /** @description A tank ID in case the timeslot's playlist_id is empty. */
      default_playlist_id?: number | null
      /**
       * @description
       * A recurrence rule.
       *
       * * 1 = once,
       * * 2 = daily,
       * * 3 = business days,
       * * 4 = weekly,
       * * 5 = biweekly,
       * * 6 = every four weeks,
       * * 7 = every even calendar week (ISO 8601),
       * * 8 = every odd calendar week (ISO 8601),
       * * 9 = every 1st week of month,
       * * 10 = every 2nd week of month,
       * * 11 = every 3rd week of month,
       * * 12 = every 4th week of month,
       * * 13 = every 5th week of month
       */
      rrule: number
      /** @description Show the schedule belongs to. */
      show: number
    }
    ScheduleResponse: {
      projected: components['schemas']['ProjectedTimeSlot'][]
      solutions: {
        [key: string]:
          | (
              | 'theirs'
              | 'ours'
              | 'theirs-start'
              | 'ours-start'
              | 'theirs-end'
              | 'ours-end'
              | 'theirs-both'
              | 'ours-both'
            )
          | undefined
      }
      notes: {
        [key: string]: number | undefined
      }
      playlists: {
        [key: string]: number | undefined
      }
      schedule: components['schemas']['Schedule']
    }
    Show: {
      id: number
      name: string
      slug: string
      /** Format: uri */
      image?: string | null
      ppoi: string
      /** Format: uri */
      logo?: string | null
      short_description: string
      description?: string | null
      /** Format: email */
      email?: string | null
      /** Format: uri */
      website?: string | null
      type: number
      fundingcategory: number
      predecessor?: number | null
      cba_series_id?: number | null
      default_playlist_id?: number | null
      category: number[]
      hosts: number[]
      owners: number[]
      language: number[]
      topic: number[]
      musicfocus: number[]
      thumbnails: readonly string[]
      is_active?: boolean
      is_public?: boolean
      links?: components['schemas']['HostLink'][]
    }
    /**
     * @description **theirs**: Discard projected timeslot. Keep existing timeslot(s).
     *
     *
     * **ours**: Create projected timeslot. Delete existing timeslot(s).
     *
     *
     * **theirs-start**: Keep existing timeslot. Create projected timeslot with start time of existing end.
     *
     *
     * **ours-start**: Create projected timeslot. Change end of existing timeslot to projected start time.
     *
     *
     * **theirs-end**: Keep existing timeslot. Create projected timeslot with end of existing start time.
     *
     *
     * **ours-end**: Create projected timeslot. Change start of existing timeslot to projected end time.
     *
     *
     * **theirs-both**: Keep existing timeslot. Create two projected timeslots with end of existing start and start of existing end.
     *
     *
     * **ours-both**: Create projected timeslot. Split existing timeslot into two:
     *
     * * set existing end time to projected start,
     * * create another timeslot with start = projected end and end = existing end.
     * @enum {string}
     */
    SolutionChoicesEnum:
      | 'theirs'
      | 'ours'
      | 'theirs-start'
      | 'ours-start'
      | 'theirs-end'
      | 'ours-end'
      | 'theirs-both'
      | 'ours-both'
    TimeSlot: {
      id: number
      show: number
      schedule: number
      /** Format: date-time */
      start: string
      /** Format: date-time */
      end: string
      memo?: string
      is_repetition?: boolean
      playlist_id?: number | null
      note_id: number | null
    }
    Topic: {
      id: number
      topic: string
      abbrev: string
      slug: string
      is_active?: boolean
    }
    Type: {
      id: number
      type: string
      slug: string
      is_active?: boolean
    }
    UnsavedSchedule: {
      id: number | null
      /** @description Number of the Weekday. */
      by_weekday: components['schemas']['ByWeekdayEnum']
      /**
       * Format: date
       * @description Start date of schedule.
       */
      first_date: string
      /**
       * Format: time
       * @description Start time of schedule.
       */
      start_time: string
      /**
       * Format: time
       * @description End time of schedule.
       */
      end_time: string
      /**
       * Format: date
       * @description End date of schedule.
       */
      last_date: string
      /** @description Whether the schedule is a repetition. */
      is_repetition?: boolean
      /** @description Add a number of days to the generated dates. This can be useful for repetitions, like 'On the following day'. */
      add_days_no?: number | null
      /** @description Whether to add add_days_no but skipping the weekends. E.g. if weekday is Friday, the date returned will be the next Monday. */
      add_business_days_only?: boolean
      /** @description A tank ID in case the timeslot's playlist_id is empty. */
      default_playlist_id?: number | null
      /**
       * @description
       * A recurrence rule.
       *
       * * 1 = once,
       * * 2 = daily,
       * * 3 = business days,
       * * 4 = weekly,
       * * 5 = biweekly,
       * * 6 = every four weeks,
       * * 7 = every even calendar week (ISO 8601),
       * * 8 = every odd calendar week (ISO 8601),
       * * 9 = every 1st week of month,
       * * 10 = every 2nd week of month,
       * * 11 = every 3rd week of month,
       * * 12 = every 4th week of month,
       * * 13 = every 5th week of month
       */
      rrule: number
      /** @description Show the schedule belongs to. */
      show: number
    }
    User: {
      id: number
      /** @description Required. 150 characters or fewer. Letters, digits and @/./+/-/_ only. */
      username: string
      first_name?: string
      last_name?: string
      /**
       * Email address
       * Format: email
       */
      email?: string
      /**
       * Staff status
       * @description Designates whether the user can log into this admin site.
       */
      is_staff?: boolean
      /**
       * Active
       * @description Designates whether this user should be treated as active. Unselect this instead of deleting accounts.
       */
      is_active?: boolean
      /**
       * Superuser status
       * @description Designates that this user has all permissions without explicitly assigning them.
       */
      is_superuser?: boolean
      password: string
      profile?: components['schemas']['Profile']
    }
  }
  responses: never
  parameters: never
  requestBodies: never
  headers: never
  pathItems: never
}

export type external = Record<string, never>

export interface operations {
  categories_list: {
    /** List all categories. */
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Category'][]
        }
      }
    }
  }
  categories_create: {
    /** Create a new category. */
    requestBody: {
      content: {
        'application/json': components['schemas']['Category']
        'application/x-www-form-urlencoded': components['schemas']['Category']
        'multipart/form-data': components['schemas']['Category']
      }
    }
    responses: {
      201: {
        content: {
          'application/json': components['schemas']['Category']
        }
      }
    }
  }
  categories_retrieve: {
    /** Retrieve a single category. */
    parameters: {
      /** @description A unique integer value identifying this category. */
      path: {
        id: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Category']
        }
      }
    }
  }
  categories_update: {
    /** Update an existing category. */
    parameters: {
      /** @description A unique integer value identifying this category. */
      path: {
        id: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['Category']
        'application/x-www-form-urlencoded': components['schemas']['Category']
        'multipart/form-data': components['schemas']['Category']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Category']
        }
      }
    }
  }
  categories_destroy: {
    /** Delete an existing category. */
    parameters: {
      /** @description A unique integer value identifying this category. */
      path: {
        id: number
      }
    }
    responses: {
      /** @description No response body */
      204: never
    }
  }
  categories_partial_update: {
    /** Partially update an existing category. */
    parameters: {
      /** @description A unique integer value identifying this category. */
      path: {
        id: number
      }
    }
    requestBody?: {
      content: {
        'application/json': components['schemas']['PatchedCategory']
        'application/x-www-form-urlencoded': components['schemas']['PatchedCategory']
        'multipart/form-data': components['schemas']['PatchedCategory']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Category']
        }
      }
    }
  }
  fundingcategories_list: {
    /** List all funding categories. */
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['FundingCategory'][]
        }
      }
    }
  }
  fundingcategories_create: {
    /** Create a new funding category. */
    requestBody: {
      content: {
        'application/json': components['schemas']['FundingCategory']
        'application/x-www-form-urlencoded': components['schemas']['FundingCategory']
        'multipart/form-data': components['schemas']['FundingCategory']
      }
    }
    responses: {
      201: {
        content: {
          'application/json': components['schemas']['FundingCategory']
        }
      }
    }
  }
  fundingcategories_retrieve: {
    /** Retrieve a single funding category. */
    parameters: {
      /** @description A unique integer value identifying this funding category. */
      path: {
        id: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['FundingCategory']
        }
      }
    }
  }
  fundingcategories_update: {
    /** Update an existing funding category. */
    parameters: {
      /** @description A unique integer value identifying this funding category. */
      path: {
        id: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['FundingCategory']
        'application/x-www-form-urlencoded': components['schemas']['FundingCategory']
        'multipart/form-data': components['schemas']['FundingCategory']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['FundingCategory']
        }
      }
    }
  }
  fundingcategories_destroy: {
    /** Delete an existing funding category. */
    parameters: {
      /** @description A unique integer value identifying this funding category. */
      path: {
        id: number
      }
    }
    responses: {
      /** @description No response body */
      204: never
    }
  }
  fundingcategories_partial_update: {
    /** Partially update an existing funding category. */
    parameters: {
      /** @description A unique integer value identifying this funding category. */
      path: {
        id: number
      }
    }
    requestBody?: {
      content: {
        'application/json': components['schemas']['PatchedFundingCategory']
        'application/x-www-form-urlencoded': components['schemas']['PatchedFundingCategory']
        'multipart/form-data': components['schemas']['PatchedFundingCategory']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['FundingCategory']
        }
      }
    }
  }
  hosts_list: {
    /** List all hosts. */
    parameters?: {
      /** @description Number of results to return per page. */
      /** @description The initial index from which to return the results. */
      query?: {
        limit?: number
        offset?: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['PaginatedHostList']
        }
      }
    }
  }
  hosts_create: {
    /** Create a new host. */
    requestBody: {
      content: {
        'application/json': components['schemas']['Host']
        'application/x-www-form-urlencoded': components['schemas']['Host']
        'multipart/form-data': components['schemas']['Host']
      }
    }
    responses: {
      201: {
        content: {
          'application/json': components['schemas']['Host']
        }
      }
    }
  }
  hosts_retrieve: {
    /** Retrieve a single host. */
    parameters: {
      /** @description A unique integer value identifying this host. */
      path: {
        id: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Host']
        }
      }
    }
  }
  hosts_update: {
    /** Update an existing host. */
    parameters: {
      /** @description A unique integer value identifying this host. */
      path: {
        id: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['Host']
        'application/x-www-form-urlencoded': components['schemas']['Host']
        'multipart/form-data': components['schemas']['Host']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Host']
        }
      }
    }
  }
  hosts_destroy: {
    /** Delete an existing host. */
    parameters: {
      /** @description A unique integer value identifying this host. */
      path: {
        id: number
      }
    }
    responses: {
      /** @description No response body */
      204: never
    }
  }
  hosts_partial_update: {
    /** Partially update an existing host. */
    parameters: {
      /** @description A unique integer value identifying this host. */
      path: {
        id: number
      }
    }
    requestBody?: {
      content: {
        'application/json': components['schemas']['PatchedHost']
        'application/x-www-form-urlencoded': components['schemas']['PatchedHost']
        'multipart/form-data': components['schemas']['PatchedHost']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Host']
        }
      }
    }
  }
  languages_list: {
    /** List all languages. */
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Language'][]
        }
      }
    }
  }
  languages_create: {
    /** Create a new language. */
    requestBody: {
      content: {
        'application/json': components['schemas']['Language']
        'application/x-www-form-urlencoded': components['schemas']['Language']
        'multipart/form-data': components['schemas']['Language']
      }
    }
    responses: {
      201: {
        content: {
          'application/json': components['schemas']['Language']
        }
      }
    }
  }
  languages_retrieve: {
    /** Retrieve a single language. */
    parameters: {
      /** @description A unique integer value identifying this language. */
      path: {
        id: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Language']
        }
      }
    }
  }
  languages_update: {
    /** Update an existing language. */
    parameters: {
      /** @description A unique integer value identifying this language. */
      path: {
        id: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['Language']
        'application/x-www-form-urlencoded': components['schemas']['Language']
        'multipart/form-data': components['schemas']['Language']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Language']
        }
      }
    }
  }
  languages_destroy: {
    /** Delete an existing language. */
    parameters: {
      /** @description A unique integer value identifying this language. */
      path: {
        id: number
      }
    }
    responses: {
      /** @description No response body */
      204: never
    }
  }
  languages_partial_update: {
    /** Partially update an existing language. */
    parameters: {
      /** @description A unique integer value identifying this language. */
      path: {
        id: number
      }
    }
    requestBody?: {
      content: {
        'application/json': components['schemas']['PatchedLanguage']
        'application/x-www-form-urlencoded': components['schemas']['PatchedLanguage']
        'multipart/form-data': components['schemas']['PatchedLanguage']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Language']
        }
      }
    }
  }
  musicfocus_list: {
    /** List all music focuses. */
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['MusicFocus'][]
        }
      }
    }
  }
  musicfocus_create: {
    /** Create a new music focus. */
    requestBody: {
      content: {
        'application/json': components['schemas']['MusicFocus']
        'application/x-www-form-urlencoded': components['schemas']['MusicFocus']
        'multipart/form-data': components['schemas']['MusicFocus']
      }
    }
    responses: {
      201: {
        content: {
          'application/json': components['schemas']['MusicFocus']
        }
      }
    }
  }
  musicfocus_retrieve: {
    /** Retrieve a single music focus. */
    parameters: {
      /** @description A unique integer value identifying this music focus. */
      path: {
        id: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['MusicFocus']
        }
      }
    }
  }
  musicfocus_update: {
    /** Update an existing music focus. */
    parameters: {
      /** @description A unique integer value identifying this music focus. */
      path: {
        id: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['MusicFocus']
        'application/x-www-form-urlencoded': components['schemas']['MusicFocus']
        'multipart/form-data': components['schemas']['MusicFocus']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['MusicFocus']
        }
      }
    }
  }
  musicfocus_destroy: {
    /** Delete an existing music focus. */
    parameters: {
      /** @description A unique integer value identifying this music focus. */
      path: {
        id: number
      }
    }
    responses: {
      /** @description No response body */
      204: never
    }
  }
  musicfocus_partial_update: {
    /** Partially update an existing music focus. */
    parameters: {
      /** @description A unique integer value identifying this music focus. */
      path: {
        id: number
      }
    }
    requestBody?: {
      content: {
        'application/json': components['schemas']['PatchedMusicFocus']
        'application/x-www-form-urlencoded': components['schemas']['PatchedMusicFocus']
        'multipart/form-data': components['schemas']['PatchedMusicFocus']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['MusicFocus']
        }
      }
    }
  }
  notes_list: {
    /** List all notes. */
    parameters?: {
      /** @description Number of results to return per page. */
      /** @description The initial index from which to return the results. */
      query?: {
        limit?: number
        offset?: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['PaginatedNoteList']
        }
      }
    }
  }
  notes_create: {
    /**
     * Create a new note.
     * @description Only admins can create new notes.
     */
    requestBody: {
      content: {
        'application/json': components['schemas']['Note']
        'application/x-www-form-urlencoded': components['schemas']['Note']
        'multipart/form-data': components['schemas']['Note']
      }
    }
    responses: {
      201: {
        content: {
          'application/json': components['schemas']['Note']
        }
      }
    }
  }
  notes_retrieve: {
    /** Retrieve a single note. */
    parameters: {
      /** @description A unique integer value identifying this note. */
      path: {
        id: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Note']
        }
      }
    }
  }
  notes_update: {
    /**
     * Update an existing note.
     * @description Only admins can update existing notes.
     */
    parameters: {
      /** @description A unique integer value identifying this note. */
      path: {
        id: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['Note']
        'application/x-www-form-urlencoded': components['schemas']['Note']
        'multipart/form-data': components['schemas']['Note']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Note']
        }
      }
    }
  }
  notes_destroy: {
    /**
     * Delete an existing note.
     * @description Only admins can delete existing notes.
     */
    parameters: {
      /** @description A unique integer value identifying this note. */
      path: {
        id: number
      }
    }
    responses: {
      /** @description No response body */
      204: never
    }
  }
  notes_partial_update: {
    /**
     * Partially update an existing note.
     * @description Only admins can partially update existing notes.
     */
    parameters: {
      /** @description A unique integer value identifying this note. */
      path: {
        id: number
      }
    }
    requestBody?: {
      content: {
        'application/json': components['schemas']['PatchedNote']
        'application/x-www-form-urlencoded': components['schemas']['PatchedNote']
        'multipart/form-data': components['schemas']['PatchedNote']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Note']
        }
      }
    }
  }
  schedules_list: {
    /** List all schedules. */
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Schedule'][]
        }
      }
    }
  }
  schedules_create: {
    /**
     * Create a new schedule.
     * @description Create a schedule, generate timeslots, test for collisions and resolve them
     * (including notes).
     *
     * Note that creating or updating a schedule is the only way to create timeslots.
     *
     * Only admins may add schedules.
     *
     * The projected timeslots defined by the schedule are matched against existing
     * timeslots. The API will return an object that contains
     *
     * * the schedule's data,
     * * projected timeslots,
     * * detected collisions,
     * * and possible solutions.
     *
     * As long as no `solutions` object has been set or unresolved collisions exist,
     * no data is written to the database. A schedule is only created if at least
     * one timeslot was generated by it.
     *
     * In order to resolve any possible conflicts, the client must submit a new request with
     * a solution for each conflict. Possible solutions are listed as part of the projected
     * timeslot in the `solution_choices` array. In a best-case scenario with no detected
     * conflicts an empty solutions object will suffice. For more details on the individual
     * types of solutions see the SolutionChoicesEnum.
     *
     * **Please note**:
     * If there's more than one collision for a projected timeslot, only `theirs` and `ours`
     * are currently supported as solutions.
     */
    requestBody: {
      content: {
        'application/json': components['schemas']['ScheduleCreateUpdateRequest']
        'application/x-www-form-urlencoded': components['schemas']['ScheduleCreateUpdateRequest']
        'multipart/form-data': components['schemas']['ScheduleCreateUpdateRequest']
      }
    }
    responses: {
      /** @description Signals the successful creation of the schedule and of the projected timeslots. */
      201: {
        content: {
          'application/json': components['schemas']['ScheduleResponse']
        }
      }
      /** @description Returns the list of timeslots that would be created, updated and deleted if the schedule request would not have been sent with the dryrun flag. */
      202: {
        content: {
          'application/json': components['schemas']['ScheduleDryRunResponse']
        }
      }
      /**
       * @description
       * Returned in case the request contained invalid data.
       *
       * This may happen if:
       * * the last date is before the start date (`no-start-after-end`),
       *   in which case you should correct either the start or until date.
       * * The start and last date are the same (`no-same-day-start-and-end`).
       *   This is only allowed for single timeslots with the recurrence rule
       *   set to `once`. You should fix either the start or until date.
       * * The number of conflicts and solutions aren’t the same
       *   (`one-solution-per-conflict`). Only one solution is allowed per conflict,
       *   so you either offered too many or not enough solutions for any reported
       *   conflicts.
       */
      400: {
        content: {
          'application/json': components['schemas']['Error']
        }
      }
      /** @description Returned in case the request contained no or invalid authenticated data or the authenticated user does not have authorization to perform the requested operation. */
      403: {
        content: {
          'application/json': components['schemas']['Error']
        }
      }
      /**
       * @description
       * Returns the list of projected timeslots and any collisions that may have
       * been found for existing timeslots.
       *
       * Errors on projected timeslots may include:
       * * 'This change on the timeslot is not allowed.'
       *   When adding: There was a change in the schedule's data during conflict
       *   resolution.
       *   When updating: Fields 'start', 'end', 'byweekday' or 'rrule' have changed,
       *   which is not allowed.
       * * 'No solution given': No solution was provided for the conflict in
       *   `solutions`. Provide a value of `solution_choices`.
       * * 'Given solution is not accepted for this conflict.':
       *   The solution has a value which is not part of `solution_choices`.
       *   Provide a value of `solution_choices` (at least `ours` or `theirs`).
       */
      409: {
        content: {
          'application/json': components['schemas']['ScheduleConflictResponse']
        }
      }
    }
  }
  schedules_retrieve: {
    /** Retrieve a single schedule. */
    parameters: {
      /** @description A unique integer value identifying this schedule. */
      path: {
        id: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Schedule']
        }
      }
    }
  }
  schedules_update: {
    /**
     * Update an existing schedule.
     * @description Update a schedule, generate timeslots, test for collisions and resolve
     * them including notes.
     *
     * Only admins may update schedules.
     */
    parameters: {
      /** @description A unique integer value identifying this schedule. */
      path: {
        id: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['ScheduleCreateUpdateRequest']
        'application/x-www-form-urlencoded': components['schemas']['ScheduleCreateUpdateRequest']
        'multipart/form-data': components['schemas']['ScheduleCreateUpdateRequest']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['ScheduleCreateUpdateRequest']
        }
      }
    }
  }
  schedules_destroy: {
    /**
     * Delete an existing schedule.
     * @description Only admins may delete schedules.
     */
    parameters: {
      /** @description A unique integer value identifying this schedule. */
      path: {
        id: number
      }
    }
    responses: {
      /** @description No response body */
      204: never
    }
  }
  schedules_partial_update: {
    /** Partially update an existing schedule. */
    parameters: {
      /** @description A unique integer value identifying this schedule. */
      path: {
        id: number
      }
    }
    requestBody?: {
      content: {
        'application/json': components['schemas']['PatchedScheduleCreateUpdateRequest']
        'application/x-www-form-urlencoded': components['schemas']['PatchedScheduleCreateUpdateRequest']
        'multipart/form-data': components['schemas']['PatchedScheduleCreateUpdateRequest']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['ScheduleCreateUpdateRequest']
        }
      }
    }
  }
  schema_retrieve: {
    /**
     * @description OpenApi3 schema for this API. Format can be selected via content negotiation.
     *
     * - YAML: application/vnd.oai.openapi
     * - JSON: application/vnd.oai.openapi+json
     */
    parameters?: {
      query?: {
        format?: 'json' | 'yaml'
        lang?:
          | 'af'
          | 'ar'
          | 'ar-dz'
          | 'ast'
          | 'az'
          | 'be'
          | 'bg'
          | 'bn'
          | 'br'
          | 'bs'
          | 'ca'
          | 'cs'
          | 'cy'
          | 'da'
          | 'de'
          | 'dsb'
          | 'el'
          | 'en'
          | 'en-au'
          | 'en-gb'
          | 'eo'
          | 'es'
          | 'es-ar'
          | 'es-co'
          | 'es-mx'
          | 'es-ni'
          | 'es-ve'
          | 'et'
          | 'eu'
          | 'fa'
          | 'fi'
          | 'fr'
          | 'fy'
          | 'ga'
          | 'gd'
          | 'gl'
          | 'he'
          | 'hi'
          | 'hr'
          | 'hsb'
          | 'hu'
          | 'hy'
          | 'ia'
          | 'id'
          | 'ig'
          | 'io'
          | 'is'
          | 'it'
          | 'ja'
          | 'ka'
          | 'kab'
          | 'kk'
          | 'km'
          | 'kn'
          | 'ko'
          | 'ky'
          | 'lb'
          | 'lt'
          | 'lv'
          | 'mk'
          | 'ml'
          | 'mn'
          | 'mr'
          | 'my'
          | 'nb'
          | 'ne'
          | 'nl'
          | 'nn'
          | 'os'
          | 'pa'
          | 'pl'
          | 'pt'
          | 'pt-br'
          | 'ro'
          | 'ru'
          | 'sk'
          | 'sl'
          | 'sq'
          | 'sr'
          | 'sr-latn'
          | 'sv'
          | 'sw'
          | 'ta'
          | 'te'
          | 'tg'
          | 'th'
          | 'tk'
          | 'tr'
          | 'tt'
          | 'udm'
          | 'uk'
          | 'ur'
          | 'uz'
          | 'vi'
          | 'zh-hans'
          | 'zh-hant'
      }
    }
    responses: {
      200: {
        content: {
          'application/vnd.oai.openapi': {
            [key: string]: unknown | undefined
          }
          'application/yaml': {
            [key: string]: unknown | undefined
          }
          'application/vnd.oai.openapi+json': {
            [key: string]: unknown | undefined
          }
          'application/json': {
            [key: string]: unknown | undefined
          }
        }
      }
    }
  }
  shows_list: {
    /** List all shows. */
    parameters?: {
      /** @description Return only currently running shows (with timeslots in the future) if true or past or upcoming shows if false. */
      /** @description Return only shows of the given category or categories. */
      /** @description Return only shows assigned to the given host(s). */
      /** @description Return only shows of the given language(s). */
      /** @description Number of results to return per page. */
      /** @description Return only shows with given music focus(es). */
      /** @description The initial index from which to return the results. */
      /** @description Return only shows that belong to the given owner(s). */
      /** @description Return only shows that are public/non-public. */
      /** @description Return only shows of the given topic(s). */
      /** @description Return only shows of a given type. */
      query?: {
        active?: boolean
        category?: number[]
        host?: number[]
        language?: number[]
        limit?: number
        musicfocus?: number[]
        offset?: number
        owner?: number[]
        public?: boolean
        topic?: number[]
        type?: number[]
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['PaginatedShowList']
        }
      }
    }
  }
  shows_create: {
    /**
     * Create a new show.
     * @description Only admins may create a show.
     */
    requestBody: {
      content: {
        'application/json': components['schemas']['Show']
        'application/x-www-form-urlencoded': components['schemas']['Show']
        'multipart/form-data': components['schemas']['Show']
      }
    }
    responses: {
      201: {
        content: {
          'application/json': components['schemas']['Show']
        }
      }
    }
  }
  shows_retrieve: {
    /** Retrieve a single show. */
    parameters: {
      /** @description A unique integer value identifying this show. */
      path: {
        id: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Show']
        }
      }
    }
  }
  shows_update: {
    /**
     * Update an existing show.
     * @description Non-admin users may only update shows they own.
     */
    parameters: {
      /** @description A unique integer value identifying this show. */
      path: {
        id: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['Show']
        'application/x-www-form-urlencoded': components['schemas']['Show']
        'multipart/form-data': components['schemas']['Show']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Show']
        }
      }
    }
  }
  shows_destroy: {
    /**
     * Delete an existing show.
     * @description Only admins may delete shows.
     */
    parameters: {
      /** @description A unique integer value identifying this show. */
      path: {
        id: number
      }
    }
    responses: {
      /** @description No response body */
      204: never
    }
  }
  shows_partial_update: {
    /** Partially update an existing show. */
    parameters: {
      /** @description A unique integer value identifying this show. */
      path: {
        id: number
      }
    }
    requestBody?: {
      content: {
        'application/json': components['schemas']['PatchedShow']
        'application/x-www-form-urlencoded': components['schemas']['PatchedShow']
        'multipart/form-data': components['schemas']['PatchedShow']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Show']
        }
      }
    }
  }
  shows_notes_list: {
    /** List all notes. */
    parameters: {
      /** @description Number of results to return per page. */
      /** @description The initial index from which to return the results. */
      query?: {
        limit?: number
        offset?: number
      }
      path: {
        show_pk: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['PaginatedNoteList']
        }
      }
    }
  }
  shows_notes_create: {
    /**
     * Create a new note.
     * @description Only admins can create new notes.
     */
    parameters: {
      path: {
        show_pk: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['Note']
        'application/x-www-form-urlencoded': components['schemas']['Note']
        'multipart/form-data': components['schemas']['Note']
      }
    }
    responses: {
      201: {
        content: {
          'application/json': components['schemas']['Note']
        }
      }
    }
  }
  shows_notes_retrieve: {
    /** Retrieve a single note. */
    parameters: {
      /** @description A unique integer value identifying this note. */
      path: {
        id: number
        show_pk: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Note']
        }
      }
    }
  }
  shows_notes_update: {
    /**
     * Update an existing note.
     * @description Only admins can update existing notes.
     */
    parameters: {
      /** @description A unique integer value identifying this note. */
      path: {
        id: number
        show_pk: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['Note']
        'application/x-www-form-urlencoded': components['schemas']['Note']
        'multipart/form-data': components['schemas']['Note']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Note']
        }
      }
    }
  }
  shows_notes_destroy: {
    /**
     * Delete an existing note.
     * @description Only admins can delete existing notes.
     */
    parameters: {
      /** @description A unique integer value identifying this note. */
      path: {
        id: number
        show_pk: number
      }
    }
    responses: {
      /** @description No response body */
      204: never
    }
  }
  shows_notes_partial_update: {
    /**
     * Partially update an existing note.
     * @description Only admins can partially update existing notes.
     */
    parameters: {
      /** @description A unique integer value identifying this note. */
      path: {
        id: number
        show_pk: number
      }
    }
    requestBody?: {
      content: {
        'application/json': components['schemas']['PatchedNote']
        'application/x-www-form-urlencoded': components['schemas']['PatchedNote']
        'multipart/form-data': components['schemas']['PatchedNote']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Note']
        }
      }
    }
  }
  shows_schedules_list: {
    /** List all schedules. */
    parameters: {
      path: {
        show_pk: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Schedule'][]
        }
      }
    }
  }
  shows_schedules_create: {
    /**
     * Create a new schedule.
     * @description Create a schedule, generate timeslots, test for collisions and resolve them
     * (including notes).
     *
     * Note that creating or updating a schedule is the only way to create timeslots.
     *
     * Only admins may add schedules.
     *
     * The projected timeslots defined by the schedule are matched against existing
     * timeslots. The API will return an object that contains
     *
     * * the schedule's data,
     * * projected timeslots,
     * * detected collisions,
     * * and possible solutions.
     *
     * As long as no `solutions` object has been set or unresolved collisions exist,
     * no data is written to the database. A schedule is only created if at least
     * one timeslot was generated by it.
     *
     * In order to resolve any possible conflicts, the client must submit a new request with
     * a solution for each conflict. Possible solutions are listed as part of the projected
     * timeslot in the `solution_choices` array. In a best-case scenario with no detected
     * conflicts an empty solutions object will suffice. For more details on the individual
     * types of solutions see the SolutionChoicesEnum.
     *
     * **Please note**:
     * If there's more than one collision for a projected timeslot, only `theirs` and `ours`
     * are currently supported as solutions.
     */
    parameters: {
      path: {
        show_pk: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['ScheduleCreateUpdateRequest']
        'application/x-www-form-urlencoded': components['schemas']['ScheduleCreateUpdateRequest']
        'multipart/form-data': components['schemas']['ScheduleCreateUpdateRequest']
      }
    }
    responses: {
      /** @description Signals the successful creation of the schedule and of the projected timeslots. */
      201: {
        content: {
          'application/json': components['schemas']['ScheduleResponse']
        }
      }
      /** @description Returns the list of timeslots that would be created, updated and deleted if the schedule request would not have been sent with the dryrun flag. */
      202: {
        content: {
          'application/json': components['schemas']['ScheduleDryRunResponse']
        }
      }
      /**
       * @description
       * Returned in case the request contained invalid data.
       *
       * This may happen if:
       * * the last date is before the start date (`no-start-after-end`),
       *   in which case you should correct either the start or until date.
       * * The start and last date are the same (`no-same-day-start-and-end`).
       *   This is only allowed for single timeslots with the recurrence rule
       *   set to `once`. You should fix either the start or until date.
       * * The number of conflicts and solutions aren’t the same
       *   (`one-solution-per-conflict`). Only one solution is allowed per conflict,
       *   so you either offered too many or not enough solutions for any reported
       *   conflicts.
       */
      400: {
        content: {
          'application/json': components['schemas']['Error']
        }
      }
      /** @description Returned in case the request contained no or invalid authenticated data or the authenticated user does not have authorization to perform the requested operation. */
      403: {
        content: {
          'application/json': components['schemas']['Error']
        }
      }
      /**
       * @description
       * Returns the list of projected timeslots and any collisions that may have
       * been found for existing timeslots.
       *
       * Errors on projected timeslots may include:
       * * 'This change on the timeslot is not allowed.'
       *   When adding: There was a change in the schedule's data during conflict
       *   resolution.
       *   When updating: Fields 'start', 'end', 'byweekday' or 'rrule' have changed,
       *   which is not allowed.
       * * 'No solution given': No solution was provided for the conflict in
       *   `solutions`. Provide a value of `solution_choices`.
       * * 'Given solution is not accepted for this conflict.':
       *   The solution has a value which is not part of `solution_choices`.
       *   Provide a value of `solution_choices` (at least `ours` or `theirs`).
       */
      409: {
        content: {
          'application/json': components['schemas']['ScheduleConflictResponse']
        }
      }
    }
  }
  shows_schedules_retrieve: {
    /** Retrieve a single schedule. */
    parameters: {
      /** @description A unique integer value identifying this schedule. */
      path: {
        id: number
        show_pk: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Schedule']
        }
      }
    }
  }
  shows_schedules_update: {
    /**
     * Update an existing schedule.
     * @description Update a schedule, generate timeslots, test for collisions and resolve
     * them including notes.
     *
     * Only admins may update schedules.
     */
    parameters: {
      /** @description A unique integer value identifying this schedule. */
      path: {
        id: number
        show_pk: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['ScheduleCreateUpdateRequest']
        'application/x-www-form-urlencoded': components['schemas']['ScheduleCreateUpdateRequest']
        'multipart/form-data': components['schemas']['ScheduleCreateUpdateRequest']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['ScheduleCreateUpdateRequest']
        }
      }
    }
  }
  shows_schedules_destroy: {
    /**
     * Delete an existing schedule.
     * @description Only admins may delete schedules.
     */
    parameters: {
      /** @description A unique integer value identifying this schedule. */
      path: {
        id: number
        show_pk: number
      }
    }
    responses: {
      /** @description No response body */
      204: never
    }
  }
  shows_schedules_partial_update: {
    /** Partially update an existing schedule. */
    parameters: {
      /** @description A unique integer value identifying this schedule. */
      path: {
        id: number
        show_pk: number
      }
    }
    requestBody?: {
      content: {
        'application/json': components['schemas']['PatchedScheduleCreateUpdateRequest']
        'application/x-www-form-urlencoded': components['schemas']['PatchedScheduleCreateUpdateRequest']
        'multipart/form-data': components['schemas']['PatchedScheduleCreateUpdateRequest']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['ScheduleCreateUpdateRequest']
        }
      }
    }
  }
  shows_schedules_timeslots_list: {
    /**
     * List all timeslots.
     * @description
     * By default, only timeslots ranging from now + 60 days will be displayed.
     * You may override this default overriding start and/or end parameter.
     */
    parameters: {
      /** @description Only returns timeslots that end on or before the specified date. By default, this is set to value of the start filter + 60 days. */
      /** @description Number of results to return per page. */
      /** @description The initial index from which to return the results. */
      /** @description Ordering */
      /** @description Only returns timeslots after that start on or after the specified date. By default, this is set to the current date. */
      /** @description Returns the 10 nearest timeslots around the specified datetime. If specified without a datetime value the current date and time is assumed. */
      query?: {
        end?: string
        limit?: number
        offset?: number
        order?: (
          | '-end'
          | '-id'
          | '-is_repetition'
          | '-memo'
          | '-note'
          | '-note_id'
          | '-playlist_id'
          | '-schedule'
          | '-show'
          | '-start'
          | 'end'
          | 'id'
          | 'is_repetition'
          | 'memo'
          | 'note'
          | 'note_id'
          | 'playlist_id'
          | 'schedule'
          | 'show'
          | 'start'
        )[]
        start?: string
        surrounding?: string
      }
      path: {
        schedule_pk: number
        show_pk: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['PaginatedTimeSlotList']
        }
      }
    }
  }
  shows_schedules_timeslots_retrieve: {
    /** Retrieve a single timeslot. */
    parameters: {
      /** @description A unique integer value identifying this time slot. */
      path: {
        id: number
        schedule_pk: number
        show_pk: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['TimeSlot']
        }
      }
    }
  }
  shows_schedules_timeslots_update: {
    /** Update an existing timeslot. */
    parameters: {
      /** @description A unique integer value identifying this time slot. */
      path: {
        id: number
        schedule_pk: number
        show_pk: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['TimeSlot']
        'application/x-www-form-urlencoded': components['schemas']['TimeSlot']
        'multipart/form-data': components['schemas']['TimeSlot']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['TimeSlot']
        }
      }
    }
  }
  shows_schedules_timeslots_destroy: {
    /**
     * Delete an existing timeslot.
     * @description Only admins may delete timeslots.
     */
    parameters: {
      /** @description A unique integer value identifying this time slot. */
      path: {
        id: number
        schedule_pk: number
        show_pk: number
      }
    }
    responses: {
      /** @description No response body */
      204: never
    }
  }
  shows_schedules_timeslots_partial_update: {
    /** Partially update an existing timeslot. */
    parameters: {
      /** @description A unique integer value identifying this time slot. */
      path: {
        id: number
        schedule_pk: number
        show_pk: number
      }
    }
    requestBody?: {
      content: {
        'application/json': components['schemas']['PatchedTimeSlot']
        'application/x-www-form-urlencoded': components['schemas']['PatchedTimeSlot']
        'multipart/form-data': components['schemas']['PatchedTimeSlot']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['TimeSlot']
        }
      }
    }
  }
  shows_schedules_timeslots_note_list: {
    /** List all notes. */
    parameters: {
      /** @description Number of results to return per page. */
      /** @description The initial index from which to return the results. */
      query?: {
        limit?: number
        offset?: number
      }
      path: {
        schedule_pk: number
        show_pk: number
        timeslot_pk: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['PaginatedNoteList']
        }
      }
    }
  }
  shows_schedules_timeslots_note_create: {
    /**
     * Create a new note.
     * @description Only admins can create new notes.
     */
    parameters: {
      path: {
        schedule_pk: number
        show_pk: number
        timeslot_pk: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['Note']
        'application/x-www-form-urlencoded': components['schemas']['Note']
        'multipart/form-data': components['schemas']['Note']
      }
    }
    responses: {
      201: {
        content: {
          'application/json': components['schemas']['Note']
        }
      }
    }
  }
  shows_schedules_timeslots_note_retrieve: {
    /** Retrieve a single note. */
    parameters: {
      /** @description A unique integer value identifying this note. */
      path: {
        id: number
        schedule_pk: number
        show_pk: number
        timeslot_pk: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Note']
        }
      }
    }
  }
  shows_schedules_timeslots_note_update: {
    /**
     * Update an existing note.
     * @description Only admins can update existing notes.
     */
    parameters: {
      /** @description A unique integer value identifying this note. */
      path: {
        id: number
        schedule_pk: number
        show_pk: number
        timeslot_pk: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['Note']
        'application/x-www-form-urlencoded': components['schemas']['Note']
        'multipart/form-data': components['schemas']['Note']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Note']
        }
      }
    }
  }
  shows_schedules_timeslots_note_destroy: {
    /**
     * Delete an existing note.
     * @description Only admins can delete existing notes.
     */
    parameters: {
      /** @description A unique integer value identifying this note. */
      path: {
        id: number
        schedule_pk: number
        show_pk: number
        timeslot_pk: number
      }
    }
    responses: {
      /** @description No response body */
      204: never
    }
  }
  shows_schedules_timeslots_note_partial_update: {
    /**
     * Partially update an existing note.
     * @description Only admins can partially update existing notes.
     */
    parameters: {
      /** @description A unique integer value identifying this note. */
      path: {
        id: number
        schedule_pk: number
        show_pk: number
        timeslot_pk: number
      }
    }
    requestBody?: {
      content: {
        'application/json': components['schemas']['PatchedNote']
        'application/x-www-form-urlencoded': components['schemas']['PatchedNote']
        'multipart/form-data': components['schemas']['PatchedNote']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Note']
        }
      }
    }
  }
  shows_timeslots_list: {
    /**
     * List all timeslots.
     * @description
     * By default, only timeslots ranging from now + 60 days will be displayed.
     * You may override this default overriding start and/or end parameter.
     */
    parameters: {
      /** @description Only returns timeslots that end on or before the specified date. By default, this is set to value of the start filter + 60 days. */
      /** @description Number of results to return per page. */
      /** @description The initial index from which to return the results. */
      /** @description Ordering */
      /** @description Only returns timeslots after that start on or after the specified date. By default, this is set to the current date. */
      /** @description Returns the 10 nearest timeslots around the specified datetime. If specified without a datetime value the current date and time is assumed. */
      query?: {
        end?: string
        limit?: number
        offset?: number
        order?: (
          | '-end'
          | '-id'
          | '-is_repetition'
          | '-memo'
          | '-note'
          | '-note_id'
          | '-playlist_id'
          | '-schedule'
          | '-show'
          | '-start'
          | 'end'
          | 'id'
          | 'is_repetition'
          | 'memo'
          | 'note'
          | 'note_id'
          | 'playlist_id'
          | 'schedule'
          | 'show'
          | 'start'
        )[]
        start?: string
        surrounding?: string
      }
      path: {
        show_pk: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['PaginatedTimeSlotList']
        }
      }
    }
  }
  shows_timeslots_retrieve: {
    /** Retrieve a single timeslot. */
    parameters: {
      /** @description A unique integer value identifying this time slot. */
      path: {
        id: number
        show_pk: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['TimeSlot']
        }
      }
    }
  }
  shows_timeslots_update: {
    /** Update an existing timeslot. */
    parameters: {
      /** @description A unique integer value identifying this time slot. */
      path: {
        id: number
        show_pk: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['TimeSlot']
        'application/x-www-form-urlencoded': components['schemas']['TimeSlot']
        'multipart/form-data': components['schemas']['TimeSlot']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['TimeSlot']
        }
      }
    }
  }
  shows_timeslots_destroy: {
    /**
     * Delete an existing timeslot.
     * @description Only admins may delete timeslots.
     */
    parameters: {
      /** @description A unique integer value identifying this time slot. */
      path: {
        id: number
        show_pk: number
      }
    }
    responses: {
      /** @description No response body */
      204: never
    }
  }
  shows_timeslots_partial_update: {
    /** Partially update an existing timeslot. */
    parameters: {
      /** @description A unique integer value identifying this time slot. */
      path: {
        id: number
        show_pk: number
      }
    }
    requestBody?: {
      content: {
        'application/json': components['schemas']['PatchedTimeSlot']
        'application/x-www-form-urlencoded': components['schemas']['PatchedTimeSlot']
        'multipart/form-data': components['schemas']['PatchedTimeSlot']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['TimeSlot']
        }
      }
    }
  }
  shows_timeslots_note_list: {
    /** List all notes. */
    parameters: {
      /** @description Number of results to return per page. */
      /** @description The initial index from which to return the results. */
      query?: {
        limit?: number
        offset?: number
      }
      path: {
        show_pk: number
        timeslot_pk: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['PaginatedNoteList']
        }
      }
    }
  }
  shows_timeslots_note_create: {
    /**
     * Create a new note.
     * @description Only admins can create new notes.
     */
    parameters: {
      path: {
        show_pk: number
        timeslot_pk: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['Note']
        'application/x-www-form-urlencoded': components['schemas']['Note']
        'multipart/form-data': components['schemas']['Note']
      }
    }
    responses: {
      201: {
        content: {
          'application/json': components['schemas']['Note']
        }
      }
    }
  }
  shows_timeslots_note_retrieve: {
    /** Retrieve a single note. */
    parameters: {
      /** @description A unique integer value identifying this note. */
      path: {
        id: number
        show_pk: number
        timeslot_pk: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Note']
        }
      }
    }
  }
  shows_timeslots_note_update: {
    /**
     * Update an existing note.
     * @description Only admins can update existing notes.
     */
    parameters: {
      /** @description A unique integer value identifying this note. */
      path: {
        id: number
        show_pk: number
        timeslot_pk: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['Note']
        'application/x-www-form-urlencoded': components['schemas']['Note']
        'multipart/form-data': components['schemas']['Note']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Note']
        }
      }
    }
  }
  shows_timeslots_note_destroy: {
    /**
     * Delete an existing note.
     * @description Only admins can delete existing notes.
     */
    parameters: {
      /** @description A unique integer value identifying this note. */
      path: {
        id: number
        show_pk: number
        timeslot_pk: number
      }
    }
    responses: {
      /** @description No response body */
      204: never
    }
  }
  shows_timeslots_note_partial_update: {
    /**
     * Partially update an existing note.
     * @description Only admins can partially update existing notes.
     */
    parameters: {
      /** @description A unique integer value identifying this note. */
      path: {
        id: number
        show_pk: number
        timeslot_pk: number
      }
    }
    requestBody?: {
      content: {
        'application/json': components['schemas']['PatchedNote']
        'application/x-www-form-urlencoded': components['schemas']['PatchedNote']
        'multipart/form-data': components['schemas']['PatchedNote']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Note']
        }
      }
    }
  }
  timeslots_list: {
    /**
     * List all timeslots.
     * @description
     * By default, only timeslots ranging from now + 60 days will be displayed.
     * You may override this default overriding start and/or end parameter.
     */
    parameters?: {
      /** @description Only returns timeslots that end on or before the specified date. By default, this is set to value of the start filter + 60 days. */
      /** @description Number of results to return per page. */
      /** @description The initial index from which to return the results. */
      /** @description Ordering */
      /** @description Only returns timeslots after that start on or after the specified date. By default, this is set to the current date. */
      /** @description Returns the 10 nearest timeslots around the specified datetime. If specified without a datetime value the current date and time is assumed. */
      query?: {
        end?: string
        limit?: number
        offset?: number
        order?: (
          | '-end'
          | '-id'
          | '-is_repetition'
          | '-memo'
          | '-note'
          | '-note_id'
          | '-playlist_id'
          | '-schedule'
          | '-show'
          | '-start'
          | 'end'
          | 'id'
          | 'is_repetition'
          | 'memo'
          | 'note'
          | 'note_id'
          | 'playlist_id'
          | 'schedule'
          | 'show'
          | 'start'
        )[]
        start?: string
        surrounding?: string
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['PaginatedTimeSlotList']
        }
      }
    }
  }
  timeslots_retrieve: {
    /** Retrieve a single timeslot. */
    parameters: {
      /** @description A unique integer value identifying this time slot. */
      path: {
        id: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['TimeSlot']
        }
      }
    }
  }
  timeslots_update: {
    /** Update an existing timeslot. */
    parameters: {
      /** @description A unique integer value identifying this time slot. */
      path: {
        id: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['TimeSlot']
        'application/x-www-form-urlencoded': components['schemas']['TimeSlot']
        'multipart/form-data': components['schemas']['TimeSlot']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['TimeSlot']
        }
      }
    }
  }
  timeslots_destroy: {
    /**
     * Delete an existing timeslot.
     * @description Only admins may delete timeslots.
     */
    parameters: {
      /** @description A unique integer value identifying this time slot. */
      path: {
        id: number
      }
    }
    responses: {
      /** @description No response body */
      204: never
    }
  }
  timeslots_partial_update: {
    /** Partially update an existing timeslot. */
    parameters: {
      /** @description A unique integer value identifying this time slot. */
      path: {
        id: number
      }
    }
    requestBody?: {
      content: {
        'application/json': components['schemas']['PatchedTimeSlot']
        'application/x-www-form-urlencoded': components['schemas']['PatchedTimeSlot']
        'multipart/form-data': components['schemas']['PatchedTimeSlot']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['TimeSlot']
        }
      }
    }
  }
  topics_list: {
    /** List all topics. */
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Topic'][]
        }
      }
    }
  }
  topics_create: {
    /** Create a new topic. */
    requestBody: {
      content: {
        'application/json': components['schemas']['Topic']
        'application/x-www-form-urlencoded': components['schemas']['Topic']
        'multipart/form-data': components['schemas']['Topic']
      }
    }
    responses: {
      201: {
        content: {
          'application/json': components['schemas']['Topic']
        }
      }
    }
  }
  topics_retrieve: {
    /** Retrieve a single topic. */
    parameters: {
      /** @description A unique integer value identifying this topic. */
      path: {
        id: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Topic']
        }
      }
    }
  }
  topics_update: {
    /** Update an existing topic. */
    parameters: {
      /** @description A unique integer value identifying this topic. */
      path: {
        id: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['Topic']
        'application/x-www-form-urlencoded': components['schemas']['Topic']
        'multipart/form-data': components['schemas']['Topic']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Topic']
        }
      }
    }
  }
  topics_destroy: {
    /** Delete an existing topic. */
    parameters: {
      /** @description A unique integer value identifying this topic. */
      path: {
        id: number
      }
    }
    responses: {
      /** @description No response body */
      204: never
    }
  }
  topics_partial_update: {
    /** Partially update an existing topic. */
    parameters: {
      /** @description A unique integer value identifying this topic. */
      path: {
        id: number
      }
    }
    requestBody?: {
      content: {
        'application/json': components['schemas']['PatchedTopic']
        'application/x-www-form-urlencoded': components['schemas']['PatchedTopic']
        'multipart/form-data': components['schemas']['PatchedTopic']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Topic']
        }
      }
    }
  }
  types_list: {
    /** List all types. */
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Type'][]
        }
      }
    }
  }
  types_create: {
    /** Create a new type. */
    requestBody: {
      content: {
        'application/json': components['schemas']['Type']
        'application/x-www-form-urlencoded': components['schemas']['Type']
        'multipart/form-data': components['schemas']['Type']
      }
    }
    responses: {
      201: {
        content: {
          'application/json': components['schemas']['Type']
        }
      }
    }
  }
  types_retrieve: {
    /** Retrieve a single type. */
    parameters: {
      /** @description A unique integer value identifying this type. */
      path: {
        id: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Type']
        }
      }
    }
  }
  types_update: {
    /** Update an existing type. */
    parameters: {
      /** @description A unique integer value identifying this type. */
      path: {
        id: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['Type']
        'application/x-www-form-urlencoded': components['schemas']['Type']
        'multipart/form-data': components['schemas']['Type']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Type']
        }
      }
    }
  }
  types_destroy: {
    /** Delete an existing type. */
    parameters: {
      /** @description A unique integer value identifying this type. */
      path: {
        id: number
      }
    }
    responses: {
      /** @description No response body */
      204: never
    }
  }
  types_partial_update: {
    /** Partially update an existing type. */
    parameters: {
      /** @description A unique integer value identifying this type. */
      path: {
        id: number
      }
    }
    requestBody?: {
      content: {
        'application/json': components['schemas']['PatchedType']
        'application/x-www-form-urlencoded': components['schemas']['PatchedType']
        'multipart/form-data': components['schemas']['PatchedType']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['Type']
        }
      }
    }
  }
  users_list: {
    /**
     * List all users.
     * @description The returned list of records will only contain a single record for non-admin users which is their own user account.
     */
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['User'][]
        }
      }
    }
  }
  users_create: {
    /**
     * Create a new user.
     * @description Only admins may create users.
     */
    requestBody: {
      content: {
        'application/json': components['schemas']['User']
        'application/x-www-form-urlencoded': components['schemas']['User']
        'multipart/form-data': components['schemas']['User']
      }
    }
    responses: {
      201: {
        content: {
          'application/json': components['schemas']['User']
        }
      }
    }
  }
  users_retrieve: {
    /**
     * Retrieve a single user.
     * @description Non-admin users may only retrieve their own user record.
     */
    parameters: {
      /** @description A unique integer value identifying this user. */
      path: {
        id: number
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['User']
        }
      }
    }
  }
  users_update: {
    /**
     * Update an existing user.
     * @description Non-admin users may only update their own user record.
     */
    parameters: {
      /** @description A unique integer value identifying this user. */
      path: {
        id: number
      }
    }
    requestBody: {
      content: {
        'application/json': components['schemas']['User']
        'application/x-www-form-urlencoded': components['schemas']['User']
        'multipart/form-data': components['schemas']['User']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['User']
        }
      }
    }
  }
  users_partial_update: {
    /**
     * Partially update an existing user.
     * @description Non-admin users may only update their own user record.
     */
    parameters: {
      /** @description A unique integer value identifying this user. */
      path: {
        id: number
      }
    }
    requestBody?: {
      content: {
        'application/json': components['schemas']['PatchedUser']
        'application/x-www-form-urlencoded': components['schemas']['PatchedUser']
        'multipart/form-data': components['schemas']['PatchedUser']
      }
    }
    responses: {
      200: {
        content: {
          'application/json': components['schemas']['User']
        }
      }
    }
  }
}
